.386
.model flat, stdcall
option casemap:none

; =======================================================

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\comctl32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comctl32.lib

; =======================================================

WinMain proto :DWORD, :DWORD, :DWORD, :DWORD
BuildTab0 proto :HWND
BuildTab1 proto :HWND
BuildTab2 proto :HWND
HideTab0 proto
HideTab1 proto
HideTab2 proto
ShowTab0 proto
ShowTab1 proto
ShowTab2 proto

; =======================================================

.const

ID										equ 150
IDM_EXIT						equ 100
ButtonID						equ 201
EditID								equ 202
ListBoxId						equ 203
StatTextId					equ 204

IDC_CHECKBOX1			equ	106
IDC_CHECKBOX2			equ	107
IDC_COMBOBOX1			equ	109
IDC_GROUPBOX1			equ	101
IDC_RADIOBUTTON1	equ	102
IDC_RADIOBUTTON2	equ	103
IDC_RADIOBUTTON3	equ	104
IDC_RICHEDIT1			equ	111
IDC_STATICFRAME1	equ	105
IDC_STATICTEXT1		equ	108
IDC_STATICTEXT2		equ	110
IDC_STATICTEXT3		equ	112
IDC_STATICTEXT4		equ	114
IDC_STATICTEXT5		equ	117
IDC_TRACKBAR1			equ	113
IDC_UPDOWN1				equ	116

.data

ClassName			db "TabControls", 0
AppName				db "Tab Controls w/o Dialogs", 0
TabTitle1			DB "Tab 1", 0				
TabTitle2			DB "Tab 2", 0
TabTitle3			DB "Tab 3", 0
szFile					db "&File", 0
szExit					db "E&xit", 0

szButton			db "button", 0
szCombobox		db "combobox", 0
szEdit   			db "edit", 0
listBox				db "listbox", 0
szStatic			db "static", 0
szTabControl	db "SysTabControl32", 0

szButtonText	db "Button", 0
szListBox			db "List Box", 0
szTab2GrpBox	db "Group Box", 0
szTab2RB1			db "RadioButton1", 0
szTab2RB2			db "RadioButton2", 0
szTab2RB3			db "RadioButton3", 0
szTab2StatFr	db "Static Frame", 0
szTab2Frame	db "Frame1", 0
szTab2Chk1		db "CheckBox1", 0
szTab2Chk2		db "CheckBox2", 0
szTab2CmbSt	db "Combo Box", 0

.data?

hInstance			HINSTANCE ?
CommandLine	LPSTR ?
hwndTab				HANDLE ?	; Handle for the Tab Control
ItemStruct		TC_ITEM <?>	; Structure used by the Tab Control
hMenu					HMENU ?
fMenu					HMENU ?
hwndStaText	HWND ?
hwndListbox	HWND ?
hwndEdit			HWND ?
hwndButton		HWND ?
nextTab				DWORD ?
curTab					DWORD ?
focusTab0			HWND ?
focusTab1			HWND ?
focusTab2			HWND ?
tb2GrpBox			HWND ?
tb2RB1					HWND ?
tb2RB2					HWND ?
tb2RB3					HWND ?
tb2StatFr			HWND ?
tb2Frame			HWND ?
tb2Chk1				HWND ?
tb2Chk2				HWND ?
tb2CmbStat		HWND ?
tb2CmbBox			HWND ?

; =======================================================

.code

start:
	invoke GetModuleHandle, NULL
	mov	hInstance, eax

	invoke GetCommandLine
	mov	CommandLine, eax

	invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess, eax

; =======================================================

WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD

	LOCAL wc			:WNDCLASSEX
	LOCAL msg		:MSG
	LOCAL hwnd	:HWND

	mov wc.cbSize, SIZEOF WNDCLASSEX
	mov wc.style, CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc, OFFSET WndProc
	mov wc.cbClsExtra, NULL
	mov wc.cbWndExtra, NULL
	push  hInstance
	pop wc.hInstance
	mov wc.hbrBackground, COLOR_WINDOW ;COLOR_WINDOW+1
	mov wc.lpszMenuName, NULL
	mov wc.lpszClassName, OFFSET ClassName

	invoke LoadIcon, NULL, IDI_APPLICATION
	mov wc.hIcon, eax
	mov wc.hIconSm, eax

	invoke LoadCursor, NULL, IDC_ARROW
	mov wc.hCursor, eax

	invoke RegisterClassEx, addr wc

	invoke CreateWindowEx, NULL, addr ClassName, addr AppName, \
		WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, \
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, \
		hInst, NULL
	mov hwnd, eax

	invoke CreateMenu
	mov hMenu, eax
	invoke CreateMenu
	mov fMenu, eax

	invoke SetMenu, hwnd, hMenu ; assign menu to window

	invoke AppendMenu, hMenu, MF_POPUP, fMenu, addr szFile
	invoke AppendMenu, fMenu, MF_STRING, IDM_EXIT, addr szExit
	invoke SetMenu, hwnd, hMenu

	invoke ShowWindow, hwnd, SW_SHOWNORMAL
	invoke UpdateWindow, hwnd

	.WHILE TRUE

		invoke GetMessage, addr msg, NULL, 0, 0
		.BREAK .IF (!eax)

		invoke TranslateMessage, addr msg
		invoke DispatchMessage, addr msg

	.ENDW

	mov	eax, msg.wParam
	ret
	
WinMain endp

; =======================================================

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

;invoke Beep, 880, 200	

	.if uMsg==WM_DESTROY

		invoke PostQuitMessage, NULL

	.elseif uMsg == WM_CREATE

		mov curTab, 0

		invoke InitCommonControls

		invoke CreateWindowEx, 0, addr szTabControl, 0, 
			WS_CHILD or WS_VISIBLE, 
			0, 0, 800, 24, hWnd, ID, hInstance, NULL
		mov hwndTab, eax
		
		.if hwndTab == NULL

			xor eax, eax
			ret

		.endif
 
		mov ItemStruct.imask, TCIF_TEXT			; Text? image? what do you want?
		mov ItemStruct.lpReserved1, 0				; Reserved
		mov ItemStruct.lpReserved2, 0				; Reserved
		mov ItemStruct.pszText, OFFSET TabTitle1	; pointer to string containing tab text 
		mov ItemStruct.cchTextMax, sizeof TabTitle1	; size of pszText
		mov ItemStruct.iImage, -1							; index to tab control's image 
		mov ItemStruct.lParam, 0							; Extra info
		invoke SendMessage, hwndTab, TCM_INSERTITEM, 0, OFFSET ItemStruct

			; Now we add the second Tab title
		mov ItemStruct.pszText, OFFSET TabTitle2
		mov ItemStruct.cchTextMax, sizeof TabTitle2
		invoke SendMessage, hwndTab, TCM_INSERTITEM, 1, OFFSET ItemStruct

			; Now we add the third Tab title
		mov ItemStruct.pszText, OFFSET TabTitle3
		mov ItemStruct.cchTextMax, sizeof TabTitle3
		invoke SendMessage, hwndTab, TCM_INSERTITEM, 2, OFFSET ItemStruct

		invoke BuildTab0, hWnd
		invoke BuildTab1, hWnd
		invoke BuildTab2, hWnd

		invoke ShowWindow, hWnd, SW_SHOWNORMAL

	.elseif uMsg == WM_NOTIFY
	
		mov eax, lParam				; lParam is a pointer to a NMHDR Struct
		mov eax, (NMHDR PTR [eax]).code

		.if eax == TCN_SELCHANGE
	
			invoke SendMessage, hwndTab, TCM_GETCURSEL, 0, 0												; Ok which one is BEING chosen right now?

				;ignore if it's same tab as before
			.if curTab != eax	

					; okay, different, need to hide prev wdw
				mov nextTab, eax

				.if curTab == 0

					invoke HideTab0

				.elseif curTab == 1

					invoke HideTab1

				.elseif curTab == 2

					invoke HideTab2

				.endif

					; now show the new tab's window
				.if nextTab == 0

					invoke ShowTab0

				.elseif nextTab == 1

					invoke ShowTab1

				.elseif nextTab == 2

					invoke ShowTab2

				.endif

				push nextTab
				pop curTab

			.endif

		.endif

	.elseif uMsg == WM_COMMAND
	
		.if wParam == IDM_EXIT

			invoke SendMessage, hWnd, WM_SYSCOMMAND, SC_CLOSE, NULL

		.endif

	.else
	
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam	
		ret ; note to self: took this out and program never showed

	.endif

	xor eax, eax
	ret
	
WndProc endp

; =======================================================

HideTab0 proc

	invoke GetFocus
	mov focusTab0, eax
	invoke ShowWindow, hwndListbox, SW_HIDE
	invoke ShowWindow, hwndStaText, SW_HIDE

	xor eax, eax
	ret
	
HideTab0 endp

; =======================================================

HideTab1 proc

	invoke GetFocus
	mov focusTab1, eax
	invoke ShowWindow, hwndEdit, SW_HIDE
	invoke ShowWindow, hwndButton, SW_HIDE

	xor eax, eax
	ret
	
HideTab1 endp

; =======================================================

HideTab2 proc

	invoke GetFocus
	mov focusTab2, eax
	invoke ShowWindow, tb2GrpBox, SW_HIDE
	invoke ShowWindow, tb2RB1, SW_HIDE
	invoke ShowWindow, tb2RB2, SW_HIDE
	invoke ShowWindow, tb2RB3, SW_HIDE
	invoke ShowWindow, tb2StatFr, SW_HIDE
	invoke ShowWindow, tb2Frame, SW_HIDE
	invoke ShowWindow, tb2Chk1, SW_HIDE
	invoke ShowWindow, tb2Chk2, SW_HIDE
	invoke ShowWindow, tb2CmbStat, SW_HIDE
	invoke ShowWindow, tb2CmbBox, SW_HIDE

	xor eax, eax
	ret
	
HideTab2 endp

; =======================================================

ShowTab0 proc

	invoke ShowWindow, hwndListbox, SW_SHOW
	invoke ShowWindow, hwndStaText, SW_SHOW
	invoke SetFocus, focusTab0

	xor eax, eax
	ret
	
ShowTab0 endp

; =======================================================

ShowTab1 proc

	invoke ShowWindow, hwndEdit, SW_SHOW
	invoke ShowWindow, hwndButton, SW_SHOW
	invoke SetFocus, focusTab1

	xor eax, eax
	ret
	
ShowTab1 endp

; =======================================================

ShowTab2 proc

	invoke ShowWindow, tb2GrpBox, SW_SHOW
	invoke ShowWindow, tb2RB1, SW_SHOW
	invoke ShowWindow, tb2RB2, SW_SHOW
	invoke ShowWindow, tb2RB3, SW_SHOW
	invoke ShowWindow, tb2StatFr, SW_SHOW
	invoke ShowWindow, tb2Frame, SW_SHOW
	invoke ShowWindow, tb2Chk1, SW_SHOW
	invoke ShowWindow, tb2Chk2, SW_SHOW
	invoke ShowWindow, tb2CmbStat, SW_SHOW
	invoke ShowWindow, tb2CmbBox, SW_SHOW

	invoke SetFocus, focusTab2

	xor eax, eax
	ret
	
ShowTab2 endp

; =======================================================

	; create controls for tab 0 (1st tab)
BuildTab0 proc hWnd:HWND

	invoke CreateWindowEx, 0, \
															addr szStatic, \
															addr szListBox,\
															WS_CHILD or WS_VISIBLE or SS_LEFT, \
															55,35,129,20, \
															hWnd, \
															StatTextId, \
															hInstance, \
															NULL
	mov  hwndStaText, eax

	invoke CreateWindowEx, WS_EX_CLIENTEDGE, \
															addr listBox, \
															NULL,\
															WS_VSCROLL or WS_VISIBLE or \
															WS_BORDER or WS_CHILD or LBS_MULTIPLESEL or \
															LBS_HASSTRINGS or LBS_NOINTEGRALHEIGHT, \
															55,55,129,100, \
															hWnd, \
															ListBoxId, \
															hInstance, \
															NULL
	mov  hwndListbox, eax

	xor eax, eax
	ret
	
BuildTab0 endp

; =======================================================

	; create controls for tab 1 (2nd tab)
BuildTab1 proc hWnd:HWND

	invoke CreateWindowEx,WS_EX_CLIENTEDGE, addr szEdit,NULL,\
					   WS_CHILD or WS_VISIBLE or WS_BORDER or ES_LEFT or \
					   ES_AUTOVSCROLL or ES_MULTILINE,\
					   50,35,200,65,hWnd,EditID,hInstance,NULL
	mov  hwndEdit,eax
	mov focusTab1, eax
	invoke ShowWindow, hwndEdit, SW_HIDE

	invoke CreateWindowEx, NULL, addr szButton, addr szButtonText,\
					  WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON,\
					  75,110,140,25,hWnd,ButtonID,hInstance,NULL
	mov  hwndButton,eax
	invoke ShowWindow, hwndButton, SW_HIDE

		;invoke ShowWindow, hwndListbox, SW_SHOW

	xor eax, eax
	ret
	
BuildTab1 endp

; =======================================================

BuildTab2 proc hWnd:HWND

	invoke CreateWindowEx, NULL, addr szButton, addr szTab2GrpBox, \
						WS_CHILD or BS_GROUPBOX or WS_VISIBLE or WS_GROUP, \
						13, 40, 150, 90, hWnd, IDC_GROUPBOX1, hInstance, NULL
	mov tb2GrpBox,eax
	invoke ShowWindow, tb2GrpBox, SW_HIDE ; SW_SHOW

	invoke CreateWindowEx, NULL, addr szButton, addr szTab2RB1, \
						BS_AUTORADIOBUTTON or WS_CHILD or WS_VISIBLE or WS_TABSTOP, \
						25, 63, 120, 14, hWnd, IDC_RADIOBUTTON1, hInstance, NULL
	mov tb2RB1,eax
	mov focusTab2, eax
	invoke ShowWindow, tb2RB1, SW_HIDE ; SW_SHOW

	invoke CreateWindowEx, NULL, addr szButton, addr szTab2RB2, \
						BS_AUTORADIOBUTTON or WS_CHILD or WS_VISIBLE or WS_TABSTOP, \
						25, 85, 120, 13, hWnd, IDC_RADIOBUTTON1, hInstance, NULL
	mov tb2RB2,eax
	invoke ShowWindow, tb2RB2, SW_HIDE

	invoke CreateWindowEx, NULL, addr szButton, addr szTab2RB3, \
						BS_AUTORADIOBUTTON or WS_CHILD or WS_VISIBLE or WS_TABSTOP, \
						25, 106, 120, 13, hWnd, IDC_RADIOBUTTON1, hInstance, NULL
	mov tb2RB3,eax
	invoke ShowWindow, tb2RB3, SW_HIDE

	invoke CreateWindowEx, NULL, addr szStatic, addr szTab2StatFr, \
						SS_LEFT or WS_CHILD or WS_VISIBLE, \
						13, 142, 90, 14, hWnd, IDC_STATICTEXT1, hInstance, NULL
	mov tb2StatFr,eax
	invoke ShowWindow, tb2StatFr, SW_HIDE

	invoke CreateWindowEx, NULL, addr szStatic, addr szTab2Frame, \
						SS_ETCHEDFRAME or WS_CHILD or WS_VISIBLE, \
						13, 162, 115, 60, hWnd, IDC_STATICFRAME1, hInstance, NULL
	mov tb2Frame,eax
	invoke ShowWindow, tb2Frame, SW_HIDE

	invoke CreateWindowEx, NULL, addr szButton, addr szTab2Chk1, \
						BS_AUTOCHECKBOX or WS_CHILD or WS_VISIBLE or WS_TABSTOP, \
						22, 172, 94, 13, hWnd, IDC_CHECKBOX1, hInstance, NULL
	mov tb2Chk1,eax
	invoke ShowWindow, tb2Chk1, SW_HIDE

	invoke CreateWindowEx, NULL, addr szButton, addr szTab2Chk2, \
						BS_AUTOCHECKBOX or WS_CHILD or WS_VISIBLE or WS_TABSTOP, \
						22, 194, 94, 14, hWnd, IDC_CHECKBOX2, hInstance, NULL
	mov tb2Chk2,eax
	invoke ShowWindow, tb2Chk2, SW_HIDE

	invoke CreateWindowEx, NULL, addr szStatic, addr szTab2CmbSt, \
						SS_LEFT or WS_CHILD or WS_VISIBLE, \
						188, 40, 90, 14, hWnd, IDC_STATICTEXT2, hInstance, NULL
	mov tb2CmbStat,eax
	invoke ShowWindow, tb2CmbStat, SW_HIDE

	invoke CreateWindowEx, WS_EX_CLIENTEDGE, addr szCombobox, NULL, \
						CBS_DROPDOWNLIST or CBS_SORT or WS_CHILD or WS_VISIBLE or WS_TABSTOP, \
						188, 60, 148, 126, hWnd, IDC_CHECKBOX2, hInstance, NULL
	mov tb2CmbBox,eax
	invoke ShowWindow, tb2CmbBox, SW_HIDE

	xor eax, eax
	ret
	
BuildTab2 endp

; =======================================================

end start
